HDU 5438 Ponds

来源:互联网 发布:37传奇霸业炼体数据 编辑:程序博客网 时间:2024/05/16 16:11

                                                           Ponds

Problem Description
Betty owns a lot of ponds, some of them are connected with other ponds by pipes, and there will not be more than one pipe between two ponds. Each pond has a valuev.

Now Betty wants to remove some ponds because she does not have enough money. But each time when she removes a pond, she can only remove the ponds which are connected with less than two ponds, or the pond will explode.

Note that Betty should keep removing ponds until no more ponds can be removed. After that, please help her calculate the sum of the value for each connected component consisting of a odd number of ponds
 

Input
The first line of input will contain a number T(1T30) which is the number of test cases.

For each test case, the first line contains two number separated by a blank. One is the numberp(1p104) which represents the number of ponds she owns, and the other is the number m(1m105) which represents the number of pipes.

The next line contains p numbers v1,...,vp, where vi(1vi108) indicating the value of pond i.

Each of the last m lines contain two numbers a and b, which indicates that pond a and pond b are connected by a pipe.
 

Output
For each test case, output the sum of the value of all connected components consisting of odd number of ponds after removing all the ponds connected with less than two pipes.
 

Sample Input
17 71 2 3 4 5 6 71 41 54 52 32 63 62 7
 

Sample Output
21
 

Source
2015 ACM/ICPC Asia Regional Changchun Online

/*
      题目大意: 给定P个池塘的价值,M个再各个池塘之间相连的管道。问去掉一些边之后,剩下所有由奇数个点组成的环(奇数环)的总价值是多少。
                    
      网络赛中比较简单的题目,却不知道该怎么去实现,顺便学习了之前一直没有接触的前向星。思路,拓扑排序找环,用dfs找奇数环。

*/
#include <algorithm>#include <iostream>#include <numeric>#include <cstring>#include <iomanip>#include <string>#include <vector>#include <cstdio>#include <queue>#include <stack>#include <cmath>#include <map>#include <set>#define LL long longconst int M = 10010;const double esp = 1e-6;const int INF = 0x3f3f3f3f;const double PI = 3.141592653589793;using namespace std;struct node{    int u,v;    int next;}ls[M*20];int hd[M],val[M],kp[M];int p,m,top;LL flag,sum;bool vis[M];queue<int>Q;void build(int x,int y){    ls[top].v = y;    ls[top].next = hd[x];    hd[x] = top++;}void grest(){    for(int i=1;i<=p;i++){        if(kp[i] < 2){            vis[i] = true;            Q.push(i);        }    }    int u,v;    while(!Q.empty()){        u = Q.front();Q.pop();        for(int i=hd[u];i!=-1;i=ls[i].next){            v = ls[i].v;            if(!vis[v]){                kp[v]--;                if(kp[v] < 2){                    vis[v] = true;                    Q.push(v);                }            }        }    }}void dfs(int x){    flag++;    vis[x] = true;    sum+=(LL)val[x];    for(int i=hd[x];i!=-1;i=ls[i].next){        if(!vis[ls[i].v]){            dfs(ls[i].v);        }    }}int main(){    int T,u,v;    while(~scanf("%d",&T)){        while(T--){            memset(hd,-1,sizeof(hd));            memset(kp,0,sizeof(kp));            memset(vis,false,sizeof(vis));            scanf("%d %d",&p,&m);            while(!Q.empty()) Q.pop();            top = 0;            for(int i=1;i<=p;i++){                scanf("%d",&val[i]);            }            for(int i=1;i<=m;i++){                scanf("%d %d",&u,&v);                build(u,v);build(v,u);                kp[u]++;kp[v]++;            }            grest();            LL ans = 0;            for(int i=1;i<=p;i++){                if(!vis[i]){                    flag = sum = 0;                    dfs(i);                    if(flag%2)                        ans+=sum;                }            }            cout<<ans<<endl;        }    }    return 0;}


0 0
原创粉丝点击